import { NgModule, enableProdMode, ErrorHandler } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { RouterModule } from '@angular/router';
import { FormsModule } from '@angular/forms';
import { HttpModule } from '@angular/http';

import { EJAngular2Module } from 'ej-angular2';

import { AppComponent } from './app.component';
import { HomeComponent } from './home/home.component';
import { GridComponent } from './grid/grid.component';
import { GridComponentA } from './grid/gridA.component';
import { GridComponentB } from './grid/gridB.component';
import { GridComponentC } from './grid/gridC.component';
import { CustomMenuButtonComponent } from './other/customMenuButton.component';
import { CustomToolbarComponent } from './other/customToolbar.component';
import { ClickOutsideModule } from 'ng-click-outside';


import { rootRouterConfig } from './app.routes';

enableProdMode();

class CustomErrorHandler implements ErrorHandler {
  call(error, stackTrace = null, reason = null) {
    console.log(error + "\n" + stackTrace);
  }
  handleError(error: any): void {
    console.log(error);
  }
}

@NgModule({
  imports: [ BrowserModule, FormsModule, HttpModule, ClickOutsideModule,RouterModule.forRoot(rootRouterConfig, { useHash: true }), EJAngular2Module.forRoot() ],
  declarations: [ AppComponent, HomeComponent, GridComponent, GridComponentA, GridComponentB, GridComponentC, CustomToolbarComponent, CustomMenuButtonComponent ],
  bootstrap: [AppComponent]
})
export class AppModule { }
