import { Component, ViewChild, ViewContainerRef, ReflectiveInjector, ComponentFactoryResolver, Input, ElementRef } from '@angular/core';
import { EJComponents } from './../../../node_modules/ej-angular2/src/ej/core';
import { GridComponent } from './../grid/grid.component';
import { GridComponentA } from './../grid/gridA.component';
import { GridComponentB } from './../grid/gridB.component';
import { GridComponentC } from './../grid/gridC.component';

@Component({
    selector: 'ej-app',
    templateUrl: './home.component.html',
	  entryComponents: [ GridComponent, GridComponentA, GridComponentB, GridComponentC ]
})
export class HomeComponent {
	    // Tab containers
      @ViewChild('tabContent0', { read: ViewContainerRef }) tabContent0: ViewContainerRef;
      @ViewChild('tabContent1', { read: ViewContainerRef }) tabContent1: ViewContainerRef;
      @ViewChild('tabContent2', { read: ViewContainerRef }) tabContent2: ViewContainerRef;
      @ViewChild('tabContent3', { read: ViewContainerRef }) tabContent3: ViewContainerRef;
      @ViewChild('tabContent4', { read: ViewContainerRef }) tabContent4: ViewContainerRef;
      @ViewChild('tabContent5', { read: ViewContainerRef }) tabContent5: ViewContainerRef;
      @ViewChild('tabContent6', { read: ViewContainerRef }) tabContent6: ViewContainerRef;
      @ViewChild('tabContent7', { read: ViewContainerRef }) tabContent7: ViewContainerRef;
      @ViewChild('tabContent8', { read: ViewContainerRef }) tabContent8: ViewContainerRef;
      @ViewChild('tabContent9', { read: ViewContainerRef }) tabContent9: ViewContainerRef;
      @ViewChild('tabContent10', { read: ViewContainerRef }) tabContent10: ViewContainerRef;

      // #tabContent* with ng components
      //tabComponents = {};
      // ComponentName + id -- tabComponentId, for example: 'GridComponent1 - #tabContent1'
      usedTabs = {};
      // Array of tabContent ids which are hidden, waiting to be used
      hiddenTabs: Array<number> = Array<number>(); 
      //
      hiddenTabsCount : number = 0;
      hiddenTabsArray : Array<Object> = new Array<Object>();
      tabContentTabAssigns : Object = {};
      tabSaltTabContentAssigns : Object = {};

      // Hidden tabs DropDown
      tabsDDDataSource: Array<Object> = [ 
        {text:"1",value:"1"}, {text:"2",value:"2"}, {text:"3",value:"3"}, {text:"4",value:"4"}, {text:"5",value:"5"}, {text:"6",value:"6"},
        {text:"7",value:"7"}, {text:"8",value:"8"}, {text:"9",value:"9"}, {text:"10",value:"10"}
        ];
      tabsDDFields: Object = { text: "text", value: "value" };
      tabsDDValue: string = "1";

      // Components DropDown     
      componentsDDDataSource: Array<Object> = [{ text: 'GridComponent', value: 'GridComponent'}, { text: 'GridComponentA', value: 'GridComponentA'}, { text: 'GridComponentB', value: 'GridComponentB'}, { text: 'GridComponentC', value: 'GridComponentC'}];
      componentsDDFields: Object = { text: "text", value: "value" };
      componentsDDValue: string = "GridComponent";

      // Tab panel
     @ViewChild('myTabPanel') myTabPanel: EJComponents<ej.Tab, any>;
	 



    // Methods
    //
    //

    // Constructor
    constructor(private resolver: ComponentFactoryResolver) {}

    // When creating new tab
    public createNewTab(componentName, tabName, componentInputs) : void
    {     
      console.log('Creating tab with componentName: ' + componentName);
      
      //var id = componentInputs['RecordId'];
      var tabSalt = componentName;

      //
      //
      // Checking if tab is already opened and if so, - focusing
      if (this.tabContentTabAssigns[this.tabSaltTabContentAssigns[tabSalt]] && !this.tabContentTabAssigns[this.tabSaltTabContentAssigns[tabSalt]].IsHidden)
      {
        console.log('Tab is in use, focusing! tabSalt: ' + tabSalt);
        //var tabNumber = this.usedTabs[tId].replace(/\D/g,'');
        this.myTabPanel.widget.showItem(Number(this.tabContentTabAssigns[this.tabSaltTabContentAssigns[tabSalt]].TabId));

        return;           
      }
      
      //
      //
      // If any unused tab exist, use it
      if (this.hiddenTabsCount > 0)
      {
        console.log('HiddenTabs exist, using them.. Tabsalt: ' + tabSalt);        
        console.log(this.tabContentTabAssigns);        
        // Hidden tabContent id, for example: 0,1,2,3,4,5,6,7,8,9.....100
//        var htId = this.hiddenTabs.shift() as number;

          var tabContentId = "";
          for (var key in this.tabContentTabAssigns)
              {
                var t = String(this.tabContentTabAssigns[key].TabId);
                if (t === String(0))
                {
                  tabContentId = key;
                  break;
                }
              }

        var tabId = 0;
        //this.hiddenTabs.shift();
        this.hiddenTabsCount--;
       
       console.log('--------------');
       console.log('Using hidden tab, id: ' + tabId);
       console.log(this.tabContentTabAssigns[tabContentId]);

        // Finding tabPanel instance
        var tabObj = this.myTabPanel.widget.element.ejTab("instance"); 
        // Findin tabs
        var tabElements = tabObj.element.find("li");
        // Changing Tab title by using Tab instance 
        this.setTabTitle(tabContentId, tabName);
        // Findin tab to show
        var tabToShow = tabElements[tabId];
        // Showing tab
         tabObj["showItem"](tabId);
         tabObj["items"][tabId]["removeAttribute"]("style");
        //this.myTabPanel.widget.showItem(htId);
        //this.myTabPanel.widget.element.ejTab({hiddenItemIndex: this.hiddenTabs });
        // Moving tab to the back of tabs row
        tabElements[tabId]["parentNode"]["append"](tabToShow);
        // Refreshing tabs
        tabObj["_itemsRefreshing"](); 
        tabObj["items"]["parent"]()["find"](".e-active")["trigger"]("click"); 

      // Updating tab Ids
        for (var t in this.tabContentTabAssigns)
            (this.tabContentTabAssigns[t] as any).TabId = "" + (Number((this.tabContentTabAssigns[t] as any).TabId) - 1);
                   
        // Adding to used tabs array
        //this.usedTabs[tId] = '#tabContent' + htId;
        this.tabContentTabAssigns[tabContentId].IsHidden = false;
        this.tabContentTabAssigns[tabContentId].TabId = "" + (this.getTabCount() - 1);
        this.tabContentTabAssigns[tabContentId].TabSalt = tabSalt;
        this.tabSaltTabContentAssigns[tabSalt] = tabContentId;
        // Loading and inserting
        this.loadComponentAndInsert(componentName, tabContentId, componentInputs);

        return;    
      }

      //
      //
      // Checking if opened tab limit is not reached and creating new tab
      if (this.isTabLimitNotReached())
      {
        console.log('Creating new tab, tabsalt: ' + tabSalt);        
        
        // Preparing
        var tabContentId = this.createTab(tabName);  
        var tabsCount = this.getTabCount();
        var _tabId = tabsCount === 0 ? "0" : "" + --tabsCount;
        this.tabContentTabAssigns[tabContentId] = { TabId: _tabId, TabSalt: tabSalt, IsHidden : false, Component: null};
        this.tabSaltTabContentAssigns[tabSalt] = tabContentId;
        console.log('TabContentId: ' + tabContentId);        

        // Loading and inserting
        this.loadComponentAndInsert(componentName, tabContentId, componentInputs);
        
        return;   
      }
      else
         console.log('Not able to create more than 10 tabs!');
    }

    // When 'X' on Tab is Clicked
    public onBeforeTabItemRemvove(args)
    { 
      console.log('Hiding tab of id: ' + args.index);  
      
     // var tab = this.tabContentTabAssigns
     // Finding tabContentId
      var tabContentId = ""; 

          for (var key in this.tabContentTabAssigns)
              {
                var t = String(this.tabContentTabAssigns[key].TabId);
                if (t === String(args.index))
                {
                  tabContentId = key;
                  break;
                }
              }
      
      console.log('TabContentId: ' + tabContentId);
            // Destroying component
            this.tabContentTabAssigns[tabContentId].Component.destroy();
            // Deleting from salt && tabContent assigns
            delete this.tabSaltTabContentAssigns[this.tabContentTabAssigns[tabContentId].TabSalt];
         
            // Creating temp variable
            var tmp = this.tabContentTabAssigns[tabContentId];
                tmp.TabId = "-1";
                tmp.IsHidden = true;
                tmp.TabSalt = "";
                tmp.Component = null;

            // Deleting tabContentTabAssigns
            delete this.tabContentTabAssigns[tabContentId];
            // Adding new to tabContentTabAssigns
            this.tabContentTabAssigns[tabContentId] = tmp;

        // Updating tab Ids
        for (var t in this.tabContentTabAssigns)
            if (Number((this.tabContentTabAssigns[t] as any).TabId) < Number(args.index))
                  {
                    if (Number((this.tabContentTabAssigns[t] as any).TabId) === -1)
                       (this.tabContentTabAssigns[t] as any).TabId = "0";
                    else
                       (this.tabContentTabAssigns[t] as any).TabId = "" + (Number((this.tabContentTabAssigns[t] as any).TabId) + 1);
                  }
   

console.log(this.tabContentTabAssigns);
         // Updating hidden tabs count
         this.hiddenTabsCount++;

          // Setting tabName (different for Detail and List)
         this.setTabTitle(tabContentId, "");

        // Finding tabPanel instance
        var tabObj = this.myTabPanel.widget.element.ejTab("instance"); 
        // Findin tabs (li)
        var tabElements = tabObj.element.find("li");
        // Finding tab to hide
        var tabToHide = tabElements[args.index];
        // Hiding
        tabObj["hideItem"](args.index); 
        tabObj["items"][args.index]["setAttribute"]("style","display:none;");
        // Moving to the beginning
        tabElements[0]["parentNode"]["prepend"](tabToHide);
        // Updating hiddent tabs index
        //this.myTabPanel.widget.option({hiddenItemIndex: this.hiddenTabs });
        // Refreshing syncfusion internal values
        tabObj["_itemsRefreshing"](); 
        tabObj["items"]["parent"]()["find"](".e-active")["trigger"]("click"); 

        // Returning
        args.cancel = true;
          
      return args;
    }


    // Buttons
    //
    //
    //

    private onCreateButtonClicked(args)
    {
      this.createNewTab(this.componentsDDValue, this.componentsDDValue, {})
    }
    private onHideButtonClicked(args)
    {    
      this.onBeforeTabItemRemvove({index: Number(this.tabsDDValue)})
    }

    // Helpers
    //
    //
    //
    // Is Tab limit reached
    private isTabLimitNotReached()
    {
      // Visible tabs count
      var tabCount = this.myTabPanel.widget.getItemsCount();

      if (tabCount < 11)
          return true;
      else 
        if (this.hiddenTabs.length > 0)
          return true;
        else
          return false;
    }

    // Create new tab
    private createTab(tabName) : string
    {
      // Tab control
      var tabPanel = this.myTabPanel.widget;

      // Visible tabs count
      var tabCount = tabPanel.getItemsCount();

      console.log('TabCount: ' + tabCount);
      // Creating tabContentId 
      var tabContentId = '#tabContent' + tabCount;         

      // Adding tab (url, displayLabel, index, cssClass, id)
      tabPanel.addItem(tabContentId, tabName, tabCount, null, tabContentId);

      // Activating tab
      tabPanel.showItem(tabCount);

      // Returning tabContentId
      return tabContentId;
    }

    private getTabCount() : number
    {
      // Tab control
      var tabObj = this.myTabPanel.widget;
      
        // if (this.hiddenTabs.length > 0)
        // {
        //   var id = this.hiddenTabs.shift();
          
        //       tabObj.showItem(id);  
        //       this.myTabPanel.widget.option({hiddenItemIndex: this.hiddenTabs });

        //   return id;
        // }

      // Visible tabs count
      var tabCount = tabObj.getItemsCount();

      return tabCount;
    }

    // Setting tab title
    private setTabTitle(tabContentId : string, title : string )
    {
        // Changing Tab title by using Tab instance 
        var tabObj = this.myTabPanel.widget.element.ejTab("instance"); 
           // tabObj.items.find("a[href='#tabContent" + tabId +"']").html(title);
            tabObj.items.find("a[href='" + tabContentId +"']").html(title);
    }

    // Load component into Tab
    private loadComponentAndInsert(componentName, tabContentId, inputData)
    {
            // Choosing where to insert component
            var vcRef : ViewContainerRef;

              switch(tabContentId)
              {
                case '#tabContent1': vcRef = this.tabContent1; break;
                case '#tabContent2': vcRef = this.tabContent2; break;
                case '#tabContent3': vcRef = this.tabContent3; break;
                case '#tabContent4': vcRef = this.tabContent4; break;
                case '#tabContent5': vcRef = this.tabContent5; break;
                case '#tabContent6': vcRef = this.tabContent6; break;
                case '#tabContent7': vcRef = this.tabContent7; break;
                case '#tabContent8': vcRef = this.tabContent8; break;
                case '#tabContent9': vcRef = this.tabContent9; break;
                case '#tabContent10': vcRef = this.tabContent10; break;    
                default: console.log('Not able to create more than 10 tabs!'); break;          
              }

        // Choosing which component to load
        var component : any; 
              switch(componentName)
              {
                case 'GridComponent': component = GridComponent; break;
                case 'GridComponentA': component = GridComponentA; break;
                case 'GridComponentB': component = GridComponentB; break;
                case 'GridComponentC': component = GridComponentC; break;   
                default: console.log('Not able to create more than 10 tabs!'); break;          
              }
        
          // Inputs need to be in the following format to be resolved properly
        let inputProviders = Object.keys(inputData).map((inputName) => {return {provide: inputName, useValue: inputData[inputName]};});
        let resolvedInputs = ReflectiveInjector.resolve(inputProviders);

        // We create an injector out of the data we want to pass down and this components injector
        let injector = ReflectiveInjector.fromResolvedProviders(resolvedInputs, vcRef.parentInjector);

        // We create a factory out of the component we want to create
        let factory = this.resolver.resolveComponentFactory(component);

        // We create the component using the factory and the injector
        let comp = factory.create(injector);

        // We insert the component into the dom container
        vcRef.insert(comp.hostView);

        // Assigning component
        this.tabContentTabAssigns[tabContentId].Component = comp;
    }




}
