import { Component, ViewChild, Input, Output, EventEmitter } from '@angular/core';
import { EJComponents } from './../../../node_modules/ej-angular2/src/ej/core'; 

@Component({
selector: 'myCustomMenuButton', 
template: `<div class=".btn"></div>
          <ej-menu #myLayoutMenu [fields.dataSource]="dataSource" [fields]="fieldSettings" contextMenuTarget= ".btn" menuType="contextmenu" (click)="onMenuItemClicked($event)"></ej-menu>
          <div [style.display]="dialogContentDisplay">
            <ej-dialog #myLayoutNameDialog title="Name" [enableResize]="false" [showOnInit]="false" width="300px">
                    <div class="container" style="width: 270px" >
                        <div class="row">
                            <div class="col-md-4"><p style="font-weight: 700; text-align:right;">Name:</p></div>
                            <div class="col-md-8" style="margin-left: 0px;"><input type="text" inputMode="ej.InputMode.Text" ej-maskedit width="170px" [(ngModel)]="userTypedName"/></div>
                        </div>
                        <div class="row"> <div class="col-md-offset-4 col-md-8" style="margin-top: 5px;"> <input type="button" ej-button value="Save" style="float: right;" (click)="onSaveButtonClicked($event)" /></div> </div>
                    </div>
                </ej-dialog>
           </div>`
})

export class CustomMenuButtonComponent  {
     // *ngIf="isVisible" 
     @ViewChild('myLayoutNameDialog') private myLayoutNameDialog: EJComponents<ej.Dialog, any>;    
     @ViewChild('myLayoutMenu') private myLayoutMenu: EJComponents<ej.Menu, any>;

     private dataSource : Array<Object> = [ { Id : 1, Text: "MenuItem1", ParentId : null }, { Id : 2, Text: "MenuItem2", ParentId : null }, { Id : 3, Text: "MenuItem3", ParentId : null }];
     private fieldSettings : Object = { parentId: "ParentId", id: "Id", text: "Text" };

     private userTypedName : string;
    // ejMenu Show
    public Show(x : number, y : number, target : string)
    {       
      this.myLayoutMenu.widget.show(x, y, ".btn", "click"); 
    }

    // ejMenu Hide
    public Hide()
    {
         this.myLayoutMenu.widget.hide();
    }

    private onMenuItemClicked(args)
    {
        console.log('Menu item clicked: ', args);
        this.myLayoutNameDialog.widget.open();
    }

    private onSaveButtonClicked(args)
    {
        console.log('Save button clicked, entered text: ' + this.userTypedName);
        this.myLayoutNameDialog.widget.close();
    }

}