import { Component, ViewEncapsulation, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { CustomMenuButtonComponent } from './customMenuButton.component';
import { ClickOutsideModule } from 'ng-click-outside';


@Component({
    selector: 'customToolbar',
    template: `<ej-toolbar [dataSource]="dataSource" [fields]="fieldsvalues" cssClass="customCssClass" [isResponsive]="true" (click)="onToolbarButtonClicked($event)"  (clickOutside)="onClickedOutside($event)"></ej-toolbar>
               <myCustomMenuButton></myCustomMenuButton>`,
    styles: [`.customCssClass { .background-color: blue; height: 50px; width: 100%; }`], 
	encapsulation: ViewEncapsulation.None,
	
})

export class CustomToolbarComponent {
	onClickedOutside(e: Event) {
     this.myCustomMenuButton.Hide();
  }
	private fieldsvalues: Object = { tooltipText: "tooltiptext", id: "id" };
	private dataSource: Array<Object> = [ { sortOrder: "1", group: "1", id: 1, tooltiptext: "Save", imageUrl: 'src/deps/images/save.png'}, { sortOrder: "2", group: "1", id: 2, tooltiptext: "Custom select menu", imageUrl: 'src/deps/images/select.png'} ];
    @ViewChild(CustomMenuButtonComponent, { read: CustomMenuButtonComponent }) myCustomMenuButton: CustomMenuButtonComponent;

    private onToolbarButtonClicked(args)
    {
        // Custom menu button
        console.log('args');
        console.log(args);
        if (args.isTrusted)
                {
                        console.log("isTrusted: ");
                        console.log("isTrusted: " + args.target.id);
                        console.log("isTrusted: ", args.target);
                        console.log(args);
                    if (args.target && args.target.id === "2")
                    {
                        console.log("show: ");
                        console.log(args.x);
                        console.log(args.y);
                        this.myCustomMenuButton.Show(args.clientX, args.clientY, ".btn"); 
                    }
                    else if (args.target && args.target.src && args.target.src.indexOf("select") > 0)
                    {
                        this.myCustomMenuButton.Show(args.clientX, args.clientY, ".btn"); 

                    }
                else
                    this.myCustomMenuButton.Hide();
                }

        if (!args.event)
            return args;
            
        var id = args.currentTarget.id;
        if (String(id) === "1")
            console.log('First button clicked!, id: ' + id);
        else
            console.log('Other button clicked, id: ' + id);

        return args;
    }
}